SystemOrganization addCategory: #'PW-Components'!

ALAjaxCounterComponent subclass: #PWAjaxCounterComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Components'!

!PWAjaxCounterComponent methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:17'!
intializeWithWikiString: anObject
	count := anObject! !

!PWAjaxCounterComponent methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:18'!
renderOn: json
	json object:
		[json name: 'count' value: count.
		"json name: 'dec' navigate: [count := count - 1].
		json name: 'inc' navigate: [count := count + 1]"]! !

!PWAjaxCounterComponent methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:18'!
wikiString: anObject
	count := anObject! !

Object subclass: #PWAjaxComponent
	instanceVariableNames: 'html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Components'!

!PWAjaxComponent class methodsFor: 'as yet unclassified' stamp: 'chc 1/2/2016 09:16'!
html: aString
	^self basicNew
		initializeWithWikiString: aString! !

!PWAjaxComponent methodsFor: 'accessing' stamp: 'chc 1/2/2016 09:17'!
html 
	^html! !

!PWAjaxComponent methodsFor: 'accessing' stamp: 'chc 1/4/2016 10:32'!
html: anObject
	html := anObject! !

!PWAjaxComponent methodsFor: 'as yet unclassified' stamp: 'chc 1/2/2016 09:16'!
initializeWithWikiString: aString
	html := aString
	! !

!PWAjaxComponent methodsFor: 'as yet unclassified' stamp: 'chc 1/2/2016 09:17'!
renderOn: json
	json object:
		[json name: 'count' value: html]! !

ALExamplePage subclass: #PWExamplePage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Components'!

!PWExamplePage methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:06'!
initialize
	examples := {
		'unicode' -> ALEncodingExample.
		'streaming' -> ALStreamingExample.
		'counter' -> ALCounterExample.
		'ajax counter' -> ALAjaxCounterExample.
		'pjax counter' -> ALPjaxCounterExample.
		'form' -> PWFormExample.
	}.
	current := examples first value new.! !

!PWExamplePage methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:06'!
renderHtmlOn: html
	html html: 
		[html head: 
			[html title: 'ooplu'.
			self renderStylesOn: html.
			 html script: '(function(i,s,o,g,r,a,m){i[''GoogleAnalyticsObject'']=r;i[r]=i[r]||function(){
  (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
  m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
  })(window,document,''script'',''https://www.google-analytics.com/analytics.js'',''ga'');

  ga(''create'', ''UA-77482044-1'', ''auto'');
  ga(''send'', ''pageview'');'.
			html link rel: 'stylesheet'; href: 'bootstrap.min.css'.
			html link rel: 'stylesheet'; href: 'blog.css' ].
		html body: [ self renderBodyOn: html ] ]! !

!PWExamplePage methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:07'!
renderNavBarOn: html
html div class: 'container'; with: [
	html nav class: 'blog-nav'; with:
		[examples do:
			[:pair | "html li: ["
				html a class: 'blog-nav-item'; navigate: [current := pair value new]; with: pair key
							"]	"
			]
		]
								].! !

PWAsyncExample subclass: #PWAjaxCounterExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PW-Components'!

!PWAjaxCounterExample methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:37'!
libraryScript

	^ '
function Counter(url) {
  this.update(url);
};

Counter.prototype.install = function Counter_install(count, dec, inc) {
  var self = this;
  this.count = $(count);
  $(dec).click(function() {self.update(self.state.dec)});
  $(inc).click(function() {self.update(self.state.inc);});
};

Counter.prototype.update = function Counter_update(url) {
  var self = this;
  $.getJSON(url, function(json) {
    self.state = json;
    self.count.html(self.state.count);
  });
};
'! !

!PWAjaxCounterExample methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:37'!
renderFormScriptOn: html

	html raw: 
		'function ConvertFormToJson(form) {
			var array = (form).serializeArray();
			var json = {};
			jQuery.each( array, function () {
			json[this.name] = this.value || '' '';
		});
		return json;
		}

		$(myform).submit(function(event){
		event.preventDefault();

		var json = ConvertFormToJson($(myform));
		console.log(json);

		jsonstring = JSON.stringify(json);
		console.log(jsonstring);

		$.ajax({
		type: "POST",
		url: "'.

	html text: (html context registerResource: self resource) printString.

	html raw: 
		'",
		data: jsonstring,
		success: function (data) {
					var self = this;
					self.state = data;
					$(''#count'').html(self.state.count);
									}
		}) 
							});'! !

!PWAjaxCounterExample methodsFor: 'as yet unclassified' stamp: 'chc 6/21/2016 08:38'!
renderInitScriptOn: html

	html raw: 'var counter = new Counter("'.
	html text: (html context registerResource: self resource) printString.
	html raw: '"); counter.install("#count", "#dec", "#inc");' ! !

!PWAjaxCounterExample methodsFor: 'as yet unclassified' stamp: 'chc 11/30/2016 11:08'!
resource
	| wikiString wikiGrammar parser html |
	
	wikiString := PWSeasidePrefsModel instance valueAt: #currentString.
	wikiGrammar := PEGParser grammarWiki.
	parser := PEGParser parserPEG parse: 'Grammar' stream: wikiGrammar actor: PEGParserParser new.
	html := parser parse: 'Page' stream: wikiString actor: PWWikiActor new.
	^ ALJsonResource component: (PWAjaxComponent html: html)! !
